#!/bin/bash
#
# rc.z_PHB-dev.sh
#
# reference stored /root/my-applications
# executable stored /root/my-applications/bin
#
# from: 
# pupsave-backup 1.3.1
# Hot Backup
# ? compress or full-size
# ? gzip or xz 
# ! if after finish, then leaves splash on screen 

#=======================================================================
# this is the Near-Original with standardized formatting and reduced options. 
#=======================================================================
# begin dev on QUIT
# begin dev on BACKUP
# begin dev on case-n-hack mainGUI
    #~ echo "??????? where am i ???????? "
    #~ lcScript_Dir=$( cd -- "$( dirname -- "${BASH_SOURCE[0]}" )" &> /dev/null && pwd )
    #
#
########################################
export gcSysDevDob="221123-0604"
export gcSysDevDob="221124-1725"
export gcSysDevDob="221125-1835"
export gcSysDevDob="221126-0500"
export gcSysDevDob="221127-0622"
export gcSysDevDob="221129-1807"
export gcSysDevDob="221130-1737"
########################################

export gcSysId="+"
export gcSysBackUpId="QCK"  # ${gcSysBackUpID}
#
export gcSysRunId="PHB"     # ${gcSysRunID}

#======= ${gcSysRunFn}   gcZeroRunDirRootBin   gcZeroRunDirRootDev =======#
#~ export gcSysRunVer="bin"     # ${gcSysRunID}   # change this # 
export gcSysRunVer="dev"     # ${gcSysRunID}   # change this # 
######
export gcSysRunFn="PHB-${gcSysRunVer}"     # ${gcSysRunFn}
#======= ${gcSysRunFn}   gcZeroRunDirRootBin   gcZeroRunDirRootDev =======#

export gcZeroRunOrg="rc.z_PHB-file.sh v.1.3.1" 

export gcZeroRun1="rc.z_${gcSysRunFn}"                              # only FN
export gcZeroRun2="/MY_/usr-share/My_Dev_/Edit_PHB/${gcZeroRun1}"   # Path plus FN
export gcZeroRunX="${0}"


#======= ${gcSysRunFn}   gcZeroRunDirRootBin   gcZeroRunDirRootDev =======#
#~ export gcSysRunVer="bin"     # ${gcSysRunID}   # change this # 
export gcSysRunVer="dev"     # ${gcSysRunID}   # change this # 
######
export gcSysRunFn="PHB-${gcSysRunVer}"     # ${gcSysRunFn}
#======= ${gcSysRunFn}   gcZeroRunDirRootBin   gcZeroRunDirRootDev =======#

#======= ${gcSysRunFn}   gcZeroRunDirRootBin   gcZeroRunDirRootDev =======#
#-----------------------------------------------------------------------
# ID two subdir used by this prg
export gcZeroRunDirRootBin="/root/my-applications/bin"
export gcZeroRunDirRootDev="/mnt/home//MY_/usr-share/My_Dev_/Edit_PHB/" 
#-----------------------------------------------------------------------
#   # select this Basic Location of Script.sh 
lcZeroRunDirTrg="$gcZeroRunDirRootDev"   # select this Basic Location of Script.sh 
#~ lcZeroRunDirTrg="$gcZeroRunDirRootBin"   # select this Basic Location of Script.sh 
#-----------------------------------------------------------------------
#======= ${gcSysRunFn}   gcZeroRunDirRootBin   gcZeroRunDirRootDev =======#


# "${0}" why not this ? file not visible in current "PATH" 
##############################################################

PATH=$PATH:/usr/lib/gtkdialog/:/root/my-applications/bin/ 
#set -x
#;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
function PHB0_ReStart() {   # Not Active 
    n=0
echo "=== (ReStart) ======================================= "

    export gcPHBzeroRun="$0" ### >>>  before any "cd -"  outside of GEANY <<<

                #~ echo "================================ ReStart ==="
                #~ echo ":${0}:" 
            #~ cd /root
                #~ echo ":${0}:" 
                #~ echo ":${gcPHBzeroRun}:" 
                #~ echo "================================ ReStart ==="
             #~ read    
 
    ${gcPHBzeroRun}     ### rc.z_CTB.sh ### >>>  before any "cd -"  or MGN

    echo "<<< (ReStart) Done :${lcZeroRunDirTrg}:<<<" 

#~ echo "cd ${lcZeroRunDirTrg} user coded" 
#~ cd ${lcZeroRunDirTrg}   # cd /SubDirSourceFile
#echo "--- 'ls' displays /mnt --- Bash Source is running from /mnt "
#~ ls
#~ read

#    echo "=== SCRIPT_DIR === [where am I] generates source path" 
#    echo " lcScript_Dir code is $( cd --  $( dirname --  ${BASH_SOURCE[0]}  ) &> /dev/null && pwd )"
    #--------------------------------------------------------------------------------------------
#   lcScript_Dir=$( cd -- "$( dirname -- "${BASH_SOURCE[0]}" )" &> /dev/null && pwd )
    #--------------------------------------------------------------------------------------------
#    echo "--- 'ls' displays /mnt --- Bash Source is running from /mnt "
    #~ ls
#    echo "=== SCRIPT_DIR ==="
#    echo "=== dirname readlink   [where am I] generates whole path-name total" 
#    echo "dirname code is '$(readlink -f '$0')"
    #--------------------------------------------------------------------------------------------
#   echo dirname "$(readlink -f "$0")"
    #--------------------------------------------------------------------------------------------

#    echo "=========================================================================="
#    echo "--- 'ls' displays /mnt --- Bash Source is running from /mnt "
#~ ls
#~ read    # show subdir

    #~ echo "======= where am I 'cd -' path ========(1a) "
	#~ cd -   # generate /SubDirSourceFile
    #~ echo "======= where am I 'cd -' path ========(1b) "
    #~ echo ""
    #~ echo "======= where am I path ========(2a) "
    #~ lcScript_Dir=$( cd -- "$( dirname -- "${BASH_SOURCE[0]}" )" &> /dev/null && pwd )
    #~ echo 'code is: $( cd -- "$( dirname -- "${BASH_SOURCE[0]}" )" &> /dev/null && pwd )'
    #~ echo "lcScript_Dir is :${lcScript_Dir}:"
    #~ echo "======= where am I path ========(2b) "
    #~ . ${lcScript_Dir}
    #~ echo "======= where am I path ========(2c) "
    #~ echo "=== end of ReStart ==="
#~ read


#echo "<<< (ReStart) Call :${lcZeroRunDirTrg}: is path !<<<" 
#~ . rc.z_PHB-dev.sh    # OK
#~ . ${0}               # OK
#. "${0}"                # OK

#
} # end: PHB0_ReStart



#;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
# ERRORMSG is used to show current ERROR param(1) 
# and is normally blank. 
# but generates empty space at top of display. 
PHB0_Help_Box() {
	echo "$ERRORMSG
<b>${gcZeroRunX}</b>
<span foreground='"'red'"'><b>:Pupsave Backup: for 'frugal' installations</b></span> 
# <span foreground='"'blue'"'>makes a backup of the live pupsave file/folder,</span>
# <span foreground='"'green'"'>saves both 'save-Folder' and 'save-FILE.4fs' .</span>
#
# <span foreground='"'red'"'> <b>:program is run under 'nice -19' control:</b></span>
# to inhibit other programs from running 
#    during the 'BackUp' operations. 

# <span foreground='"'red'"'>BASH script: </span><span foreground='"'green'"'>
# reference stored /root/my-applications
# executable stored /root/my-applications/bin
# ReStart works on /root/my-applications/bin </span>

<b>1)</b> The date and time is automatically appended 
to the backup file name as "YYMMDD_SS".

<b>2)</b> For safest results, shut down all applications 
and servers before backing up.

<b>3)</b> <span foreground='"'green'"'>Program backs up system configuration (saveDATA) </span>
as it exists in the pupsave. <span foreground='"'red'"'>
It will not backup data stored outside the pupsave.</span>

To restore a backup, rename the file by removing the 
<b>.BKP-xxxx.xx.xx-xx.xx</b> file extension.

You must be running a frugal install (mode=13)
otherwise ${gcZeroRunX} will not run." > /tmp/box_help
	/usr/lib/gtkdialog/box_help "Pupsave Backup Help"
}
export -f PHB0_Help_Box

#~ You can force the init script to not ignore pupsaves 
#~ created by this script by adding a boot parameter
#~ : pfix=psavebkp



#;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
#~ function Show_SplashIt() {   # NOT Active
#~ # called: Show_SplashIt "text" "fg" "bg" "timeout"
#~ /usr/lib/gtkdialog/box_splash -text "${1}" -fg "${2}" -bg "${3}"  -timeout "${4}"  
 	#~ GtkPid_SplashIt=$! 
    #~ kill ${GtkPid_SplashIt} > /null
#~ } # end: fx(Show_SplashIt)
#~ export -f Show_SplashIt

#;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
#~ function show_splash() {   # NOT Active
	#~ /usr/lib/gtkdialog/box_splash -close never -text "$@" &
	#~ pidx=$!
#~ } # end: fx(show_splash)
#~ export -f show_splash

#~ <b>Run from /root/my-applictions/filename
#~ <b>Edit in Geany
#~ <b>Execute in 'Terminal' 

#;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
function PHB0_Splash_Wait() {   # ACTIVE : generates RunTime Splash 
# Begin Splash TarOpt
#;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
/usr/lib/gtkdialog/box_splash -fg yellow -bg darkred -close never \
-text " 
  ${1} 
                          " &
export GcPidSplashWait=$!
echo ">>> (_Splash_Wait_)_${GcPidSplashWait}_<<<" 
sleep 1  
# kill ${GcPidSplashWait} later. 
} # end: PHB0_Splash_TarOpt


#---------------------------------
function PHB_CleanUp() {
    n=0
	rm -rf ${gcFlag_PSHB_Lock}  ### "Soft-Lock" allows user to re-start. 
    #
	busybox ps | grep 'PBKP_PUPSAVE_HOT_BKP' | grep -v grep | awk '{print $1}' | \
	#
    while read pid ; do kill $pid ; done
    #
	# returns to             echo "(ft14) exit 0"  
} # end: fx(PHB_CleanUp)
export -f PHB_CleanUp
trap PHB_CleanUp SIGHUP SIGINT SIGTERM

#------------------------------------------------------------------------
# Verify frugal type installation.
. /etc/rc.d/PUPSTATE
export PUPMODE
case $PUPMODE in
	12|13) ok=1 ;;
	*) ERRORMSG="Hot Backup can only be used if there is an active pupsave..." ;;
esac


#------------------------------------------------------------------------
if [ "$ERRORMSG" ] ; then
	PHB_CleanUp
	echo "$ERRORMSG"
	ERRORMSG="<b><span foreground='"'red'"'>${ERRORMSG}</span></b>
"
	[ $DISPLAY ] && PHB0_Help_Box
	PHB_CleanUp
	exit 1
fi


#;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
function PHB_ERROR_Show() {  # NOT used
		/usr/lib/gtkdialog/box_ok "Pupsave Backup" error "Error(s) creating ${1}"
} # end: PHB_ERROR_Show


#;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
function PHB_ERROR_RESTART() {   # ACTIVE called 2 times 

	/usr/lib/gtkdialog/box_ok "Pupsave Backup" error "$@"

	PHB_CleanUp
	pupsave-backup &
} # end: fx(PHB_ERROR_RESTART)


#;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
function PBKP_MBrequired() { # $PBKP_PUPSAVE_PATH
	a=$(du -c -m -s "$1") #-c = --total, -m = --block-size=1m, -s = --summarize
	read -r aa bb <<< "$a"
	echo -n "MB required: $aa  [might need even more]"
} # end: fx(PBKP_MBrequired)

#;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
function PBKP_MBavailable() { # $PBKP_BACKUP_PATH $PBKP_PUPSAVE_PATH
    n=0
    # echo/display this var, in GUI .
	bkp="${1}"
	case "$bkp" in
		"/mnt/home"*|"/initrd/mnt/dev_save"*) drv="dev_save" ;;
		"/mnt/"*) drv="`echo "$bkp" | cut -f 3 -d '/'`";;
		*) PHB_ERROR_RESTART "You can only back up a pupsave to a device mounted on /mnt ..." ; return 1 ;;
	esac

    #~ Show_SplashIt "(mb1) begin 'MBavailable'" "black" "green" "3" 
    #~ Show_SplashIt "(mb1)" "black" "green" "3" 
    # gae, cannot call Show_SplashIt at this point, GUI will loop on timer. 

	a="`df -k | grep "$drv" | awk '{ print $4 }'`"
	if [ "$a" = "" ] ; then
		a=0
	else
		a=$((a/1024)) #mb
	fi
	[ "$drv" = "dev_save" ] && drv="/initrd/mnt/dev_save"
	lbldrv="/mnt/$drv"
	[ "$drv" = "/initrd/mnt/dev_save" ] && lbldrv=$drv
	#-
	fs=$(grep "${drv} " /proc/mounts | cut -f 3 -d ' ')
	if [ "$fs" = "" ] ; then
		PHB_ERROR_RESTART "$drv: STORAGE DEVICE NOT MOUNTED... You can only back up a pupsave to a device mounted on /mnt"
		return 1
	fi
	if [ "$SaveDataNbr" ] ; then
		case $fs in ext[2-4]) ok=1 ;;
			*) PHB_ERROR_RESTART "$drv has a invalid filesystem: $fs ... You can only back up savefolders to a ext2/ext3/ext4 partition..." ; return 1 ;;
		esac
	fi
	aa="$(du -c -m -s "$2")" #-c = --total, -m = --block-size=1m, -s = --summarize # error flag on Zero-length file 
	read -r b ccc <<< "$aa"
	#-
	echo -n "MB available on ${lbldrv}: $a"
	if [ $((a-b)) -le 100 ]; then # not enough space
		/usr/lib/gtkdialog/box_ok "Pupsave Backup" error "NOT ENOUGH FREE DISK SPACE on $drv..."
		return 1
	fi

} # end: fx(PBKP_MBavailable)


#;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
function PBKP_Bkpfilename() { # $PBKP_PUPSAVE_PATH
	echo -n "Backup file name: ${PBKP_PUPSAVE_NAME}.${gcSysBackUpId}-`date +%Y.%m.%d_%H%M.%S`"
} # end: fx(PBKP_Bkpfilename)


#;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
function PBKP_validate_BACKUP_location() { # $PBKP_BACKUP_PATH
	if [ "${1}" != "" ]; then 
		IFS="/" read -r a direntry level2 level3 level4 <<< "${1}"
		#                /mnt     /home  /psubidir                /mnt/sda2/etc
		if [ "$direntry" = "mnt" ] && [ "$level2" != "" ] ; then
			echo -n "${1}"
		elif [ "$direntry"/"$level2" = "initrd/mnt" ] && [ "$level3" != "" ] ; then
			echo -n "${1}"
		fi
    else
		echo -n "$PBKP_LOCDEFAULT"
	fi
} # end: fx(PBKP_validate_BACKUP_location)
 

#;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
function PHB_Tar-Var-Set() {
    n=0
    # purpose: force 'default' value into TAREXT and TAROPT 
    # method: Automatically PreSelect  vintage Unix TAR.GZ  into  TAROPT variable, 
    #   defaulted to TAR and gzip . 

            TAROPT="-z"
            TAREXT='tar.gz'
            TAROPT="-c -z --checkpoint=1000" 

                    #~ /usr/lib/gtkdialog/box_yesno "Pupsave Backup-Compress" "Do you want to compress the backup ${destfile} ?

                    #~ May take a bit longer but save some space."
                        #~ if [ $? -eq 0 ] ; then # yes
                            #~ /usr/lib/gtkdialog/box_yesno --yes-label "gzip" --no-label "xz" --yes-icon "gtk-execute" --no-icon "gtk-execute" \
                            #~ "Pupsave Backup-Compress" "Select compression type: 'gzip' or 'xz'"
                            #~ if [ $? -eq 0 ] ; then
                                #~ TAROPT="-z"
                                #~ TAREXT='tar.gz'
                            #~ else
                                #~ TAROPT="-J"
                                #~ TAREXT='tar.xz'
                            #~ fi
                        #~ fi
} # end: fx(PHB_Tar-Var-Set)


#;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
function PBKP_Backup() { #$PBKP_PUPSAVE_PATH $PBKP_BACKUP_PATH
    n=0
    lcBackupColor="yellow"
    echo "(B1) running fx(Backup)"
    echo "SourceFile:${1}:param1"

     # orig: destfile=".${2}"/"`expr "${1}" | awk -F / '{print $NF}'`".${gcSysBackUpId}-`date +%Y.%m.%d_%H%M.%S`
	destfile=".${2}"/"`expr "${1}" | awk -F / '{print $NF}'`".${gcSysBackUpId}-`date +%y%m%d_%H%M.%S`

	#~ if [ $PUPMODE -eq 13 ] ; then #flash

        PHB0_Splash_Wait "(${gcSysRunId}) nice -19 snapmergepuppy"
        echo "(B2) Begin Mode = 13  :  SMP to save${type}"
        #;;;;;;;;;;;;;;;;;;;;;;;;;
        nice -19 snapmergepuppy         
        #;;;;;;;;;;;;;;;;;;;;;;;;;
        echo "(B2) End Mode = 13  :  SMP to save${type}"
        kill ${GcPidSplashWait}

                #~ else
                    #~ /usr/lib/gtkdialog/box_ok "Pupsave Backup" error "Error(s) Not Mode 13"
                    #~ return 1 
                #~ fi

    #~ echo "(B3) move XLOADED > & sync"
	mv /root/.XLOADED /etc/xloadedx
	sync
	sleep 0.5

	CWDIR=$PWD
   
	### if  File.4FS   ##################################################################    
	### if  File.4FS   ##################################################################    
	### if  File.4FS   ##################################################################    
    if [ "$SaveDataNbr" ] ; then   # test for "0" "FILE.4GS" value in var, 

        #~ echo "(TO) SaveDataNbr is FILE.4FS"

		PHB_Tar-Var-Set ### purpose: force 'default' value into TAROPT 

        # TAROPT has a Tar Operatonal Values set via  sbr "PHB_Tar-Var-Set"
		[ "$TAROPT" ] && destfile=${destfile}.${TAREXT} # if value then define destfile

       	### if Folder/Directory #################################################    
        # if "$SaveDataNbr" has a value of "1" 
        # if sbr "PHB_Tar-Var-Set" has run proper
		if [ "$TAROPT" ] ; then   # extra 
            # TAROPT has a value via  sbr PHB_Tar-Var-Set
            #~ echo "(B5) if save Folder/Directory"

			cd ${1%/*} # change dir so TAR can see 
            # dirname $PBKP_PUPSAVE_PATH
			# basename destfile / basename $PBKP_PUPSAVE_PATH

			#~ echo ; echo "tar ${TAROPT} -f ${destfile##*/} ${1##*/}/" #debug
            #~ echo "===" ; echo "(TO) Begin TarOpt :${TAROPT}:Folder/Directory:" ; echo "=== Begin Creating ${destfile##*/}" ; echo "" 

            # PHB0_Splash_Wait >>> TarOpt Creating
            PHB0_Splash_Wait "(${gcSysRunId}) ^Folder/Directory^
         TarOpt  Creating
        ===Please Wait ===
        ${destfile##*/}"   # Big Splash   
            destfile=${destfile}   # .${TAREXT}
            #~ echo "=== Folder/Directory ==="; echo "destfile ${destfile##*/}"; echo "=== Folder/Directory ==="

            #===========================================================
			tar ${TAROPT} -f ${destfile##*/} ${1##*/}/
            #===========================================================

			RETVAL=$?
            echo "" ; echo "(TO) end TarOpt :${TAROPT}: Folder/Directory:=======" ; echo ""

		    kill ${GcPidSplashWait}   # End Splash TarOpt

			cd "$CWDIR"  # change dir back to normal view

            echo "(B9) synch" 
			sync
     
		#~ else    # else [ "$TAROPT" ] has "0" value , which is type "File.4FS"
            #~ n=0
            #~ # distractor
            #~ # logically, PHB cannot get into this block of code.
            #~ # so, why ? this 'else' block of code. 
            #~ # 
            #~ # doing Error Trap on 'exist' rsync
        	#~ mkdir -p ${destfile}
			#~ if which rsync ; then   # returns "/usr/bin/rsync"
				#~ rsync -aX ${1}/ ${destfile}/
				#~ RETVAL=$?
			#~ else    # find "rsync" param 
				#~ find "${1}" -mindepth 1 -maxdepth 1 | while read i ; do
                      #~ # cp 
                      #~ # -a --archive
                      #~ #    --attributes-only        don't copy the file data, just the attributes
                      #~ #    --backup[=CONTROL]       make a backup of each existing destination file
                      #~ # --remove-destination     
                      #~ #      remove each existing destination file before
                      #~ #            attempting to open it (contrast with --force)
                    #~ # ? 
					#~ cp -a --remove-destination ${i} ${destfile}/
					#~ RETVAL=$?
					#~ sync
				#~ done
			#~ fi

			sync    # now run sync

		fi # end: extra # if [ "$TAROPT" ] ; then # type "1" "Folder/Directory"  # 
        
	### else File.4FS ##################################################################    
	### else File.4FS ##################################################################    
	### else File.4FS ##################################################################    
    else   # if [ "$SaveDataNbr" ] = "0"  which is type "Folder/Directory"
           

        #~ echo "(B5) else save Folder/Directory"

		PHB_Tar-Var-Set # force default values into TAROPT TAREXT
        #~ echo "(B6) copy 'XLOADED' to destfile"
		cp -f -v "${1}" "${destfile}" 2> /dev/null
		RETVAL=$? # not used 

        #~ echo "(B7) sync"
		sync
    
        # run e2fsck on "Folder/Directory"
        #~ echo "(B8) >>> e2fsck -y ${destfile}"
		e2fsck -y "${destfile}" 2> /dev/null

		if [ "$TAROPT" ] ; then
			#~ echo ; echo "tar ${TAROPT} -f ${destfile##*/} ${1##*/}/" #debug
            #~ echo "" ; echo "(TO) begin TarOpt :${TAROPT}:File.4FS:" ; echo "=== Begin Creating ${destfile##*/}" ; echo ""
            
			cd ${1%/*} # changedir so TAR can run local 
            # dirname $PBKP_PUPSAVE_PATH

            # PHB0_Splash_Wait >>> TarOpt Creating
            PHB0_Splash_Wait "(${gcSysRunId}) File.4FS 
          TarOpt Creating
        === Please Wait ===
        ${destfile##*/}"   # Big Splash

			prevdfile=${destfile}
			destfile=${destfile}   

            #~ echo "=== File.4FS ==="; echo "destfile ${destfile##*/}"; echo "=== File.4FS ===" #debug
            #~ read

            #=== FOLDER =========================================================
			tar ${TAROPT} -f ${destfile##*/} ${prevdfile##*/} #basename $destfile
            #====================================================================

			RETVAL=$?
			rm -f $prevdfile

		    kill ${GcPidSplashWait}   # End Splash TarOpt
            echo "" ; echo "(TO) end TarOpt :${TAROPT}: File.4FS:=======" ; echo ""

		fi
	fi
    
    #~ echo "(B8) <<< copy 'xloadedx' back into to orig subdir"
	mv /etc/xloadedx /root/.XLOADED
	sync

	if [ $RETVAL -eq 0 ] ; then

        # PHB0_Splash_Wait >>> TarOpt DONE
        PHB0_Splash_Wait "\
    (${gcSysRunId}) 
TarOpt Save${type} 
Backup Completed:
    ---DONE---  "
        sleep 5
        kill ${GcPidSplashWait}

lcMsgStr=\
".___________________________.
. 
.   (${gcSysRunId}) TarOpt Save${type} 
.     Backup Completed:
.       ---DONE---  
.___________________________.
.                                       "
xmessage  -name 'PHB' -center -bg brown -fg yellow "${lcMsgStr}"

        #~ /usr/lib/gtkdialog/box_ok "Pupsave Backup" complete "(B9) Save${type} Backup Completed:
        #~ ---DONE---
        #~ ${destfile}"
        return 0
	else # retval is "1" 
		rm -rf $destfile
		/usr/lib/gtkdialog/box_ok "Pupsave Backup" error "Error(s) creating $destfile"   ### error
		return 1
	fi
} # end: fx(PBKP_Backup)



##################################### Execution #######################################
#####################################   main()  #######################################
#####################################   main()  #######################################
#####################################   main()  #######################################


#Find and verify path of currently mounted save file.
SF="`echo $PUPSAVE | cut -f 3 -d ","`" # /savefilename or /xxx/savefilename

lcMsgStr="(M)--- Main(${gcZeroRun})---:${0}:---:(${SF}):"
echo "(M)--- Main( ${gcZeroRun} ) --- (${SF})"  #  2> /dev/null

#~ lcMsgStr=\
#~ ".___________________________.
#~ . 
#~ .   (${gcSysRunId}) TarOpt Save${type} 
#~ .     Backup Completed:
#~ .       ---DONE---  
#~ .___________________________.
#~ .                                       "
#~ xmessage  -name 'PHB' -center -bg brown -fg yellow "${lcMsgStr}"

#~ read
#~ exit

if [ ! "$SF" ] ; then
	/usr/lib/gtkdialog/box_ok "Pupsave Backup" error "Currently using a full partition..."   ### error
	PHB_CleanUp
	exit
fi

#SF=${SF#/}
if [ ! -e "/mnt/home${SF}" ]; then   # Error Trapped 
	/usr/lib/gtkdialog/box_ok "Pupsave Backup" error "'/mnt/home${SF}' does not exist!"   ### error
	PHB_CleanUp
	exit 1

elif [ -d "/mnt/home${SF}" ]; then  # save-Directory

    echo "(M) SF = save-DIRECTOIRY" # 
    export SaveDataType="Directory"
	export SaveDataNbr=1
	export REFRESH_INTERVAL=1000 #1 seconds
	export type=folder

else # save-Folder

    echo "(M) SF = save-FOLDER" 
    export SaveDataType="Folder"
	export SaveDataNbr=0
	export REFRESH_INTERVAL=1000 #1 seconds
	export type=file
fi

# Export variables
export PBKP_PUPSAVE_PATH="/mnt/home${SF}"
export PBKP_PUPSAVE_NAME="${SF##*/}" #${SF##*/} = basename $SF
export PBKP_LOCDEFAULT="/mnt/home${PSUBDIR}"
export PBKP_BACKUP_PATH=$(PBKP_validate_BACKUP_location)

case "$PBKP_PUPSAVE_NAME" in *".BKP-"*)   # test for dupe filename 
    lcMsgStr="seems to be a file produced by this script.
    It's not advised to use it,
    the file name might become too large..."
	/usr/lib/gtkdialog/box_ok "Pupsave Backup" warning "'${PBKP_PUPSAVE_NAME}' ${lcMsgStr}" ### error
esac
# Exported functions
export -f PHB_Tar-Var-Set PHB_ERROR_RESTART PBKP_MBrequired PBKP_MBavailable PBKP_Bkpfilename PBKP_Backup PBKP_validate_BACKUP_location

# For fileselect dialog default directory
cd /mnt

#--- set LockFile ---------------------------------------------------------------------
gcFlag_PSHB_Lock="/tmp/flag_PSHB_lock "
if [ -f ${gcFlag_PSHB_Lock} ];then
    n=0
	#~ rm -rf ${gcFlag_PSHB_Lock}  ### "Soft-Lock" allows user to re-start. 
	#~ /usr/lib/gtkdialog/box_ok "Pupsave Backup" error "Backup is already running, Soft-Lock."
    #~ PHB_CleanUp
	#~ exit 1
else
    n=0
    touch ${gcFlag_PSHB_Lock}
fi


echo "(G) begin GUI"  # > /dev/console
   
##############################   mainGUI  #######################################
##############################   mainGUI  #######################################
##############################   mainGUI  #######################################

# Some escapement is necessary when this sed is used to allow comments in gui.

gcBkpStatus="BackUp Status: ???"  # '${gcSysInfo}'

#~ export lcGuiTitle="PHB-dev-PupSave Hot-Backup for Frugal Pups : '${SaveDataType}'  '${gcSysId}' :"
#~ export lcGuiTitle="PHB-dev: '${SaveDataType}'  '${gcSysId}' :"
export lcGuiTitle=" :${gcSysRunFn} : '${SaveDataType}' : '${gcSysId}' : '${gcSysDevDob}' ---"
export PBKP_PUPSAVE_HOT_BKP='
<window title="'${lcGuiTitle}'" icon-name="gtk-convert" default_width="750" space-expand="true" border-width="2"  resizable="true">
    <vbox>

	    <button has-focus="false" height-request="30" 
			 	tooltip-text="'---${lcZeroRunDirTrg}---'" >
				<label> '---Hot-BackUp-v.1.3---' </label>
				<action>lxDummy:Title</action>
		</button>


    <frame>
      <hbox>
            <entry editable="false">
               <variable>PBKP_PUPSAVE_PATH</variable>
               <sensitive>"false"</sensitive>
               <input>echo -n "'\$PBKP_PUPSAVE_PATH'"</input>
            </entry>
      </hbox>
         <text editable="false" use-markup="true" xalign="0.001">
            <label>"<span color='"'blue'"'>Save backup to /mnt/??</span>"</label>
         </text>
      <hbox>
            <entry editable="false" accept="directory">
               <variable>PBKP_BACKUP_PATH</variable>
               <input>PBKP_validate_BACKUP_location "'\$PBKP_BACKUP_PATH'"</input>
            </entry>
            <button>
               <input file stock="gtk-open"></input>
               <action type="fileselect">PBKP_BACKUP_PATH</action>
               <action>refresh:TEXT2</action>
            </button>
      </hbox>
    </frame>

    <frame information>

         <text height-request="" xalign="0">
            <variable>TEXT1</variable>
            <input>PBKP_MBrequired "'\$PBKP_PUPSAVE_PATH'"</input>
         </text>
         <text height-request="20" xalign="0">
            <variable>TEXT2</variable>
            <input>PBKP_MBavailable "'\$PBKP_BACKUP_PATH'" "'\$PBKP_PUPSAVE_PATH'"</input>
         </text>
         <text height-request="20" xalign="0">
            <variable>BKPFILE</variable>
            <input>PBKP_Bkpfilename "'\$PBKP_PUPSAVE_PATH'"</input>
         </text>
         <timer milliseconds="true" interval="'${REFRESH_INTERVAL}'" visible="false"> 
           <action>refresh:TEXT1</action>
           <action>refresh:TEXT2</action>
           <action>refresh:BKPFILE</action>
           <action>refresh:PBKP_BACKUP_PATH</action>
         </timer>
    </frame>
      <hbox>
         <button help><action>PHB0_Help_Box &</action></button>
         <button>
            <input file icon="gtk-save"></input>
            <label>'Backup'</label>
            <action>EXIT:BACKUP</action>
            <action>PBKP_Backup "'\$PBKP_PUPSAVE_PATH'" "'\$PBKP_BACKUP_PATH'" &</action>
         </button>
         <button use-stock="true" label="'gtk-quit'" has-focus="true">
            <action>EXIT:QUIT</action>
         </button>
         <button visible="" use-stock="true" label="'.'" has-focus="true">
            <action>EXIT:RESTART</action>
         </button>
         <button visible="" use-stock="true" label="'..'" has-focus="true">
            <action>EXIT:RESTART</action>
         </button>
      </hbox>
    </vbox>
</window>
'

#-----------------------------------------------------------------------
#~ eval "`gtkdialog --center -p PBKP_PUPSAVE_HOT_BKP`" 
#-----------------------------------------------------------------------
### below: AUTO: eval ,pause 3, auto-run Backup. 
eval "`gtkdialog --center -p PBKP_PUPSAVE_HOT_BKP`" & sleep 3 &
### AUTO: Fall-Thru 
PBKP_Backup "$PBKP_PUPSAVE_PATH" "$PBKP_BACKUP_PATH" & EXIT="QUIT" &
#-----------------------------------------------------------------------


         #~ <text editable="false" use-markup="true" xalign=".5">
            #~ <label>"<span color='"'red'"'>'${gcBkpStatus}'</span>"</label>
         #~ </text>

           #~ <text><label>"xxx"</label></text>

        #~ <text editable="false" use-markup="true" xalign=".5">
            #~ <label>"<span color='"'blue'"'>Save backup to /mnt/???</span>"</label>
         #~ </text>

#~ eval "`gtkdialog --center -p PBKP_PUPSAVE_HOT_BKP`"
# eval ,pause 3, auto-run Backup. 
#~ eval "`gtkdialog --center -p PBKP_PUPSAVE_HOT_BKP`" & sleep 3 &

#-----------------------------------------------------------------------
# AUTO: eval ,pause 3, auto-run Backup. 
#~ eval "`gtkdialog --center -p PBKP_PUPSAVE_HOT_BKP`" & sleep 3 &
# AUTO: Fall-Thru 
#~ PBKP_Backup "$PBKP_PUPSAVE_PATH" "$PBKP_BACKUP_PATH"
#-----------------------------------------------------------------------

#;;; FALL-THRU ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
if [ "$EXIT" = "BACKUP" ] ; then  # Gui First Call 
 
    echo ""
    echo "===================================================="
    echo "(ft11) Gui ${EXIT} = BACKUP ::gcZeroRun=${gcZeroRun}:" 

	if PBKP_MBavailable "$PBKP_BACKUP_PATH" ; then
        echo "(ft12) MKBavailable : RETVAL=:${RETVAL}:gcZeroRun=${gcZeroRun}:"

        # Calls Main Backup 
		if PBKP_Backup "$PBKP_PUPSAVE_PATH" "$PBKP_BACKUP_PATH" ; then 
            #~ echo "(ft13) PBKP_Backup: RETVAL={$RETVAL}: gcZeroRun=${gcZeroRun}:" 
			#~ PHB_CleanUp
            #~ echo "(ft14) exit 0 : if PBKP_Backup is OK" 
            PHB0_ReStart
			#~ exit 0 #success
		fi
        #~ echo "(ft15) : if PBKP_Backup is NOT"
        #~ echo "(ft15X) exit 0 : if PBKP_Backup is NOT"
        #~ echo "(ft15 XX ) >>> PHB0_ReStart" 
        #~ PHB0_ReStart
        #~ echo "(ft15 XX ) <<< PHB0_ReStart" 
        #~ echo "(ft15) : if PBKP_Backup is NOT"
	fi
	# error ? recovery is via ReStart 
 	#error
	#~ cleanup
	#~ cd -
	#~ $0 & #reenter
	#~ exit 1

   #~ echo ""
    #~ echo "===================================================="
    #~ echo "(ft16) PHB_CleanUp, cd : RETVAL={$RETVAL}:gcZeroRun=${gcZeroRun}:"    
	PHB_CleanUp
    ### below: requires two "QUIT" to terminate ---------------------
	# cd -   # cd /SubDirSourceFile
	# . $0 & #reenter
    #----------------------------------------------------------------
	exit 1 
    #
fi # end: if [ "$EXIT" = "BACKUP" ]


#;;; FALL-THRU ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
# EXIT:RESTART
if [ "$EXIT" = "RESTART" ] ; then  # Gui First Call , called by many sbr
    n=0
    # PHB0_Splash_Wait >>> 
    PHB0_Splash_Wait "(ReStart)"
    sleep 1
    GcPidSplashWait=$!
    kill ${GcPidSplashWait}
    #
	PHB0_ReStart
     #
fi # end: if [ "$EXIT" = "RESTART" ]



#;;; FALL-THRU ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
if [ "$EXIT" = "QUIT" ] ; then  # Gui First Call 
    n=0
	PHB_CleanUp
    #~ echo ""
    #~ echo "=== DONE ================================================="
    #~ echo "(ft87) Gui ${EXIT} = QUIT :gcZeroRun=${gcZeroRun}:" 
	#~ cd -    # cd /SubDirSourceFile
    #~ echo "=== where am I ==="  
    #~ lcScript_Dir=$( cd -- "$( dirname -- "${BASH_SOURCE[0]}" )" &> /dev/null && pwd )
    #~ echo "${lcScript_Dir}"  # path 
    
fi # end: if [ "$EXIT" = "QUIT" ]




#;;; FALL-THRU ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
# function Catch-All
    # via cleanup: 	rm -rf ${gcFlag_PSHB_Lock}  ### "Soft-Lock" allows user to re-start. 
    echo ""
    echo "===================================================="
echo "(ft98) Catch-All: Else $EXIT='FallThru' === END === " # > /dev/console
# fi # end: Catch-All: $EXIT="FallThru" 

### END ##################################################################


    #~ # appears that "ERRORMSG" is a reserved word.
    #~ ERRORMSG="SomeMsg"  && PHB0_Help_Box  # no color
	#~ ERRORMSG="<b><span foreground='"'red'"'>${ERRORMSG}</span></b>" && PHB0_Help_Box # color
    #~ echo "${ERRORMSG}" && PHB0_Help_Box   # color
    #~ echo "${DISPLAY}" && PHB0_Help_Box   # color
