#!/bin/bash
#
####################################################################################
###  "EXR" at   /initrd/mnt/dev_save/MY_/usr-share/My_Dev_/Edit_EXR/rc.z_EXR.sh
### method: Back 3 Root, copy "/My_Dev_" into "/root/my-applications" and  "/bin" 
####################################################################################
#
# Has NO mainGUI.  No user selections.
# todo: clean up. possibly insert whole into "MGN.sh"
# has been inserted into MGN.sh
# this file not updted from MGN.sh, yet. 



###^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^
export gcSysDevDobPrev=""
export gcSysDevDob="221011-0430"
export gcSysDevDob="221027-0935"
export gcSysDevDob="221027-1805"
export gcSysDevDob="221028-0630"
export gcSysDevDob="221028-2230"
export gcSysDevDob="221029-0600"
export gcSysDevDob="221030-1000"
export gcSysDevDob="221101-0500"
export gcSysDevDob="221108-0836"
export gcSysDevDob="221110-0400"
export gcSysDevDob="221127-0630"
export gcSysDevDob="221219-0606"
export gcSysDevDob="221219-1050"
export gcSysDevDob="221219-1917"
###^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^
#(: System Developer ID name of this Linux BASH script
export gcEXRDevId="EXR"	
###^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^
#:### MGN PATH  "rc.sysinit" calls functions_x to check/link "/etc/rc.d"
#:### PATH=/bin:/sbin:/usr/bin:/usr/sbin:/usr/local/bin:/usr/X11R7/bin:/etc/rc.d:/root/my-applications/bin/ 
#~ PATH=/bin:/sbin:/usr/bin:/usr/sbin:/usr/local/bin:/usr/X11R7/bin:/etc/rc.d:/usr/lib/gtkdialog/:/root/my-applications/bin/
PATH=$PATH:/usr/lib/gtkdialog/:/root/my-applications/bin/
###^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^




########################################################################
### begin: fx(EXR) #####################################################
########################################################################
########################################################################
### begin: fx(EXR) #####################################################
########################################################################
########################################################################
### begin: fx(EXR) #####################################################
########################################################################



#!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
# begin: EXR_SBR  ######################################################
#!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

#!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
# EXR_SBR  ########################################################
#!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
#(: ====================================================================
#(: fx(EXR_CopySplash)   #: Active  
#(: called by: fx(EXR_Copy_One)
#(: param: 
#(: purpose: 
#(: calls: 
#(: method:  Splash: delay kill prev, splash 
#(: sends: 
#(: rationale: 
#(: note : 
#(:
#:##################################################
function EXR_CopySplash() {   #: Active
    n=0
### Dialog Copy Splash Check 
### 4 
lcParam1="${1}"
### lcSrcFnBase setup by caller EXR_Copy_One 

    kill ${GTKPIDCHK}    ### kill any previous splash

#--------------------------------------------------------------------------------------------------------------
/usr/lib/gtkdialog/box_splash -fg yellow -bg black -close never -text "          ${lcParam1}             " &  
#--------------------------------------------------------------------------------------------------------------

	GTKPIDCHK=$!	### kill #((splash
    sleep .5
        # DELAY:
        # kill ${GTKPIDCHK} 
        # All Use Same PID, so Single Late Kill 
        #---------------------------------------
} # end: EXR_CopySplash



#!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
# EXR_SBR  EXR_CopyOne #################################################
#!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
#(: ====================================================================
#(: fx(EXR_CopyOne)   #: A  
#(: called by:
#(: param: 
#(: purpose: 
#(: calls: fx(EXR_CopySplash)
#(: method: 
#(: sends: 
#(: rationale: 
#(: note :
#(:
#:##################################################
function EXR_CopyOne() {   #: NOT
    n=0

    lcSrcFnBaseID="${1}"
    lcSrcFnTitleP="${2}"
    lcSrcFnTitlePS="${3}"	# subdir

	EXR_CopySplash	"${lcSrcFnBaseID}"    # CopyOne && 	sleep .5

    lcSrcFnCopyPP="/initrd/mnt/dev_save/MY_/usr-share/My_Dev_/Edit_${lcSrcFnBaseID}/${lcSrcFnTitleP}"
    lcTrgFnCopyPP="/root/my-applications"

    cp -v ${lcSrcFnCopyPP} ${lcTrgFnCopyPP}  

	sleep .3
	kill ${GTKPIDCHK} 
} # end: fx(EXR_CopyOne)


#!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
# EXR_SBR  EXR_CopyOneBin ##############################################
#!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
#(: ====================================================================
#(: fx(EXR_CopyOneBin)   #: Active  
#(: called by:
#(: param: 
#(: purpose: 
#(: calls: 
#(: method: 
#(: sends: 
#(: rationale: 
#(: note :
#(:
#:##################################################
function EXR_CopyOneBin() {   #: Active
    n=0

    lcSrcFnBaseID="${1}"
    lcSrcFnTitleP="${2}"

	EXR_CopySplash	"${lcSrcFnBaseID}"    # CopyOneBin && 	sleep .5

    lcSrcFnCopyPP="/initrd/mnt/dev_save/MY_/usr-share/My_Dev_/Edit_${lcSrcFnBaseID}/${lcSrcFnTitleP}"
    lcTrgFnCopyPP="/root/my-applications/bin"

    cp -v ${lcSrcFnCopyPP} ${lcTrgFnCopyPP}  

	sleep .3

} # end: fx(E2$_CopyOneBin)


#!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
# EXR_SBR  EXR_CopyOneDirect ###########################################
#!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
#(: ====================================================================
#(: fx(EXR_CopyOneDirect)   #: Active  
#(: called by: EXR_Main_Run
#(: param:   FnBase, SrcFnAll, TrgFnAll
#(: purpose: 
#(: calls: 
#(: method:  EXR_CopyOneDirect "SrcFnBase" "SrcFnAll" "TrgFnAll"
#(: sends: 
#(: rationale: 
#(: note : parameters are ticky 
#(:
#:##################################################
function EXR_CopyOneDirect() {   #: A
    n=0
    # EXR_CopyOneDirect receives Param: BaseP (ID), SrcFnAllP (fn), AllP (TrgFileNameAll)
    lcSrcFnBaseID="${1}"
    # "MntPone" 
    lcSrcFnAll="${2}"
    # "/initrd/mnt/dev_save/MY_/usr-share/My_Dev_/Edit_MNT/rc.z_MntPone.sh"
    lcTrgFnAll="${3}"
    # "/root/my-applications/bin"

	EXR_CopySplash	"${lcSrcFnBaseID}"
    # CopyOneDirect && 	sleep .5

    cp -v ${lcSrcFnAll} ${lcTrgFnAll}  

    echo "cp -v ${lcSrcFnAll} ${lcTrgFnAll}" >> /EXR.log
	sleep .3

} # end: fx(EXR_CopyOneDirect)

#!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
# end: EXR_SBR  ########################################################
#!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!




########################################################################
### begin: fx(EXR_Main_Run) ############################################
########################################################################
#(: ====================================================================
#(: fx(EXR_Main_Run)   #: Active  
#(: called by: EXR Main ()
#(: param:  
#(: purpose: 
#(: calls: 
#(: method:  EXR_CopyOneDirect "SrcFnBase" "SrcFnAll" "TrgFnAll"
#(: sends: 
#(: rationale: 
#(: note:
#(: funxtion is to backup all these modules 
#(:   into "/root/my-applications"  # archive
#(:   into "/root/my-applications/bin" # future "running" subdir in PATH .
#(:  MGN, C2M, C3C, CTB, CTU, CTM, CBU, CTC, EXR, 
#(:  MNT, S2F, RCZ, WRM, PLY, 
#(:  GTK, ABT, YAF, PMT, TST,  SLP, BMA, MNU 
#(:
#:######################################################################
function EXR_Main_Run() {   #: Active : run LONG LIST of EXR specific code 
    n=0


    # External call 
	#~ lcFnRun="/initrd/mnt/dev_save/MY_/usr-share/My_Dev_/Edit_EXR/rc.z_EXR.sh" 
    # External call 

export gcEXRDevId="EXR"	

    lcMsgStr=">>> begin: running EXTERNAL.sh ====================="
    #~ Sbr_Str2DevTrm "$lcMsgStr" "2" "3"
    #~ Sbr_Str2DevTrm "$lcMsgStr" "2" "3"
    #~ Sbr_Str2DevTrm "$lcMsgStr" "2" "3"
    sleep 1

#~ if [ 0 -eq 0 ] ; then
	#~ lnDummy=0
    #~ return
#~ fi ### end: if [ 0 -eq 1 ]

if [ 0 -eq 1 ] ; then 
	n=0
    echo "======= quick exit  "
    # return # up one level will continue the long EXR multi subr series. 
    exit 0 # will stop, clean termination
fi ### end: if [ 0 -eq 1 ]


if [ ! -f "/root/my-applications/0-***Files*for*BackupReference_" ] ; then
    touch /root/my-applications/0-***Files*for*BackupReference_ 
    touch /root/my-applications/0-***Files*for*BackupReference__ 
    touch /root/my-applications/0-***Files*for*BackupReference___ 
fi
if [ ! -f "/root/my-applications/bin/0-***___Executable_Files_for_RUNNING_" ] ; then
    touch /root/my-applications/bin/0-***___Executable_Files_for_RUNNING_
    touch /root/my-applications/bin/0-***___Executable_Files_for_RUNNING__
    touch /root/my-applications/bin/0-***___Executable_Files_for_RUNNING___
fi


### <<< begin Long Form Copy ###############################
### <<< begin Long Form Copy ###############################
### <<< begin Long Form Copy ###############################

    echo "${0} EXR.sh =======" > /EXR.log

### <<< begin Long Form Copy ###############################
### <<< begin Long Form Copy ###############################
### <<< begin Long Form Copy ###############################

        ### example ###       cp -v ${lcSrcFnAll} ${lcTrgFnAllP}  # ${2} ${3} 

    ### ft(MGN) ### ------------- ### Copy-----Code #############################
    lcSrcOneSubDir="MGN"
    lcSrcOneFnID="MGN"
    lcSrcOneFnAll="/initrd/mnt/dev_save/MY_/usr-share/My_Dev_/Edit_${lcSrcOneSubDir}/rc.z_${lcSrcOneFnID}.sh"

        lcTrgOneSubAll="/root/my-applications"
        EXR_CopyOneDirect ${lcSrcOneFnID} ${lcSrcOneFnAll} ${lcTrgOneSubAll} 

        lcTrgOneSubAll="/root/my-applications/bin"
        EXR_CopyOneDirect ${lcSrcOneFnID} ${lcSrcOneFnAll} ${lcTrgOneSubAll} 

    ### ft(MGR) ### ------------- ### Copy-----Code #############################
    lcSrcOneSubDir="MGR"
    lcSrcOneFnID="MGR"
    lcSrcOneFnAll="/initrd/mnt/dev_save/MY_/usr-share/My_Dev_/Edit_${lcSrcOneSubDir}/rc.z_${lcSrcOneFnID}.sh"
        lcTrgOneSubAll="/root/my-applications"
        EXR_CopyOneDirect ${lcSrcOneFnID} ${lcSrcOneFnAll} ${lcTrgOneSubAll} 
        lcTrgOneSubAll="/root/my-applications/bin"
        EXR_CopyOneDirect ${lcSrcOneFnID} ${lcSrcOneFnAll} ${lcTrgOneSubAll} 

    ### ft(CTB) ### ------------- ### Copy-----Code #############################
    lcSrcOneSubDir="CTB"
    lcSrcOneFnID="CTB"   # CTB   561  # real running version
    lcSrcOneFnAll="/initrd/mnt/dev_save/MY_/usr-share/My_Dev_/Edit_${lcSrcOneSubDir}/rc.z_${lcSrcOneFnID}.sh"
        lcTrgOneSubAll="/root/my-applications"
        EXR_CopyOneDirect ${lcSrcOneFnID} ${lcSrcOneFnAll} ${lcTrgOneSubAll} 
        lcTrgOneSubAll="/root/my-applications/bin"
        EXR_CopyOneDirect ${lcSrcOneFnID} ${lcSrcOneFnAll} ${lcTrgOneSubAll} 
    ### ft(CTA) ### ------------- ### Copy-----Code #############################
    lcSrcOneSubDir="CTA"
    lcSrcOneFnID="CTA"   # CTA   569
    lcSrcOneFnAll="/initrd/mnt/dev_save/MY_/usr-share/My_Dev_/Edit_${lcSrcOneSubDir}/rc.z_${lcSrcOneFnID}.sh"
        lcTrgOneSubAll="/root/my-applications"
        EXR_CopyOneDirect ${lcSrcOneFnID} ${lcSrcOneFnAll} ${lcTrgOneSubAll} 
        lcTrgOneSubAll="/root/my-applications/bin"
        EXR_CopyOneDirect ${lcSrcOneFnID} ${lcSrcOneFnAll} ${lcTrgOneSubAll} 
    ### ft(CTU) ### ------------- ### Copy-----Code #############################
    lcSrcOneSubDir="CTU"
    lcSrcOneFnID="CTU"   # CTU 576
    lcSrcOneFnAll="/initrd/mnt/dev_save/MY_/usr-share/My_Dev_/Edit_${lcSrcOneSubDir}/rc.z_${lcSrcOneFnID}.sh"
        lcTrgOneSubAll="/root/my-applications"
        EXR_CopyOneDirect ${lcSrcOneFnID} ${lcSrcOneFnAll} ${lcTrgOneSubAll} 
        lcTrgOneSubAll="/root/my-applications/bin"
        EXR_CopyOneDirect ${lcSrcOneFnID} ${lcSrcOneFnAll} ${lcTrgOneSubAll} 


#################################################################################
if [ 0 -eq 0 ] ; then # master EXR_Int_Main control : allows Short List Testing
#################################################################################
 
    ### ft(rc.z_TXN_exe) ### ------------- ### Copy-----Code #############################
    lcSrcOneSubDir="TXN"
    lcSrcOneFnID="TXN_exe"   # PHB for "file.4FS" a copy of "file.4fs" version. 
        lcSrcOneFnAll="/initrd/mnt/dev_save/MY_/usr-share/My_Dev_/Edit_${lcSrcOneSubDir}/rc.z_${lcSrcOneFnID}.sh"
        lcTrgOneSubAll="/root/my-applications"
        EXR_CopyOneDirect ${lcSrcOneFnID} ${lcSrcOneFnAll} ${lcTrgOneSubAll} 
        lcTrgOneSubAll="/root/my-applications/bin"
        EXR_CopyOneDirect ${lcSrcOneFnID} ${lcSrcOneFnAll} ${lcTrgOneSubAll} 

    ### ft(PHB-deb) ### ------------- ### Copy-----Code #############################
    lcSrcOneFnID="PHB_deb"   # PHB for "file.4FS" a copy of "file.4fs" version. 
    lcSrcOneSubDir="PHB"
        lcSrcOneFnAll="/initrd/mnt/dev_save/MY_/usr-share/My_Dev_/Edit_${lcSrcOneSubDir}/rc.z_${lcSrcOneFnID}.sh"
        lcTrgOneSubAll="/root/my-applications"
        EXR_CopyOneDirect ${lcSrcOneFnID} ${lcSrcOneFnAll} ${lcTrgOneSubAll} 
        lcTrgOneSubAll="/root/my-applications/bin"
        EXR_CopyOneDirect ${lcSrcOneFnID} ${lcSrcOneFnAll} ${lcTrgOneSubAll} 

    #~ ### ft(PHB-quick) ### ------------- ### Copy-----Code #############################
    #~ lcSrcOneFnID="PHB_quick"   # PHB for "file.4FS" a copy of "file.4fs" version. 
    #~ lcSrcOneSubDir="PHB"
        #~ lcSrcOneFnAll="/initrd/mnt/dev_save/MY_/usr-share/My_Dev_/Edit_${lcSrcOneSubDir}/rc.z_${lcSrcOneFnID}.sh"
        #~ lcTrgOneSubAll="/root/my-applications"
        #~ EXR_CopyOneDirect ${lcSrcOneFnID} ${lcSrcOneFnAll} ${lcTrgOneSubAll} 
        #~ lcTrgOneSubAll="/root/my-applications/bin"
        #~ EXR_CopyOneDirect ${lcSrcOneFnID} ${lcSrcOneFnAll} ${lcTrgOneSubAll} 

    ### ft(GTK-dev) ### ------------- ### Copy-----Code #############################
    lcSrcOneFnID="GTK_dev"  
    lcSrcOneSubDir="GTK"
        lcSrcOneFnAll="/initrd/mnt/dev_save/MY_/usr-share/My_Dev_/Edit_${lcSrcOneSubDir}/rc.z_${lcSrcOneFnID}.sh"
        lcTrgOneSubAll="/root/my-applications"
        EXR_CopyOneDirect ${lcSrcOneFnID} ${lcSrcOneFnAll} ${lcTrgOneSubAll} 
        lcTrgOneSubAll="/root/my-applications/bin"
        EXR_CopyOneDirect ${lcSrcOneFnID} ${lcSrcOneFnAll} ${lcTrgOneSubAll} 

    ### ft(MNT) ### ------------- ### Copy-----Code #############################
    lcSrcOneFnID="MNT"
    lcSrcOneSubDir="MNT"
        lcSrcOneFnAll="/initrd/mnt/dev_save/MY_/usr-share/My_Dev_/Edit_${lcSrcOneSubDir}/rc.z_${lcSrcOneFnID}.sh"
        lcTrgOneSubAll="/root/my-applications"
        EXR_CopyOneDirect ${lcSrcOneFnID} ${lcSrcOneFnAll} ${lcTrgOneSubAll} 
        lcTrgOneSubAll="/root/my-applications/bin"
        EXR_CopyOneDirect ${lcSrcOneFnID} ${lcSrcOneFnAll} ${lcTrgOneSubAll} 
    ### ft(MntPone) ### ------------- ### Copy-----Code #############################
    lcSrcOneFnID="MntPone" 
    lcSrcOneSubDir="MNT"  # MntPone
        lcSrcOneFnAll="/initrd/mnt/dev_save/MY_/usr-share/My_Dev_/Edit_${lcSrcOneSubDir}/rc.z_${lcSrcOneFnID}.sh"
        lcTrgOneSubAll="/root/my-applications"
        EXR_CopyOneDirect ${lcSrcOneFnID} ${lcSrcOneFnAll} ${lcTrgOneSubAll} 
        lcTrgOneSubAll="/root/my-applications/bin"
        EXR_CopyOneDirect ${lcSrcOneFnID} ${lcSrcOneFnAll} ${lcTrgOneSubAll} 
    ### ft(MntUone) ### ------------- ### Copy-----Code #############################
    lcSrcOneFnID="MntUone"  
    lcSrcOneSubDir="MNT" # MntUone
        lcSrcOneFnAll="/initrd/mnt/dev_save/MY_/usr-share/My_Dev_/Edit_${lcSrcOneSubDir}/rc.z_${lcSrcOneFnID}.sh"
        lcTrgOneSubAll="/root/my-applications"
        EXR_CopyOneDirect ${lcSrcOneFnID} ${lcSrcOneFnAll} ${lcTrgOneSubAll} 
        lcTrgOneSubAll="/root/my-applications/bin"
        EXR_CopyOneDirect ${lcSrcOneFnID} ${lcSrcOneFnAll} ${lcTrgOneSubAll} 
    ### ft(C2M) ### ------------- ### Copy-----Code #############################
    lcSrcOneFnID="C2M"   # C2M
    lcSrcOneSubDir="C2M"
        lcSrcOneFnAll="/initrd/mnt/dev_save/MY_/usr-share/My_Dev_/Edit_${lcSrcOneSubDir}/rc.z_${lcSrcOneFnID}.sh"
        lcTrgOneSubAll="/root/my-applications"
        EXR_CopyOneDirect ${lcSrcOneFnID} ${lcSrcOneFnAll} ${lcTrgOneSubAll} 
        lcTrgOneSubAll="/root/my-applications/bin"
        EXR_CopyOneDirect ${lcSrcOneFnID} ${lcSrcOneFnAll} ${lcTrgOneSubAll} 
    ### ft(C3C) ### ------------- ### Copy-----Code #############################
    lcSrcOneFnID="C3C"   # C3C
    lcSrcOneSubDir="C3C"
        lcSrcOneFnAll="/initrd/mnt/dev_save/MY_/usr-share/My_Dev_/Edit_${lcSrcOneSubDir}/rc.z_${lcSrcOneFnID}.sh"
        lcTrgOneSubAll="/root/my-applications"
        EXR_CopyOneDirect ${lcSrcOneFnID} ${lcSrcOneFnAll} ${lcTrgOneSubAll} 
        lcTrgOneSubAll="/root/my-applications/bin"
        EXR_CopyOneDirect ${lcSrcOneFnID} ${lcSrcOneFnAll} ${lcTrgOneSubAll} 
    ### ft(S2F) ### ------------- ### Copy-----Code #############################
    lcSrcOneFnID="S2F"   # S2F
    lcSrcOneSubDir="S2F"
        lcSrcOneFnAll="/initrd/mnt/dev_save/MY_/usr-share/My_Dev_/Edit_${lcSrcOneSubDir}/rc.z_${lcSrcOneFnID}.sh"
        lcTrgOneSubAll="/root/my-applications"
        EXR_CopyOneDirect ${lcSrcOneFnID} ${lcSrcOneFnAll} ${lcTrgOneSubAll} 
        lcTrgOneSubAll="/root/my-applications/bin"
        EXR_CopyOneDirect ${lcSrcOneFnID} ${lcSrcOneFnAll} ${lcTrgOneSubAll} 
    ### ft(S2F-1) ### ------------- ### Copy-----Code #############################
    lcSrcOneFnID="S2F-1"   # S2F-1
    lcSrcOneSubDir="S2F"
        lcSrcOneFnAll="/initrd/mnt/dev_save/MY_/usr-share/My_Dev_/Edit_${lcSrcOneSubDir}/rc.z_${lcSrcOneFnID}.sh"
        lcTrgOneSubAll="/root/my-applications"
        EXR_CopyOneDirect ${lcSrcOneFnID} ${lcSrcOneFnAll} ${lcTrgOneSubAll} 
        lcTrgOneSubAll="/root/my-applications/bin"
        EXR_CopyOneDirect ${lcSrcOneFnID} ${lcSrcOneFnAll} ${lcTrgOneSubAll} 
    ### ft(S2F-3) ### ------------- ### Copy-----Code #############################
    lcSrcOneFnID="S2F-3"   # S2F-3
    lcSrcOneSubDir="S2F"
        lcSrcOneFnAll="/initrd/mnt/dev_save/MY_/usr-share/My_Dev_/Edit_${lcSrcOneSubDir}/rc.z_${lcSrcOneFnID}.sh"
        lcTrgOneSubAll="/root/my-applications"
        EXR_CopyOneDirect ${lcSrcOneFnID} ${lcSrcOneFnAll} ${lcTrgOneSubAll} 
        lcTrgOneSubAll="/root/my-applications/bin"
        EXR_CopyOneDirect ${lcSrcOneFnID} ${lcSrcOneFnAll} ${lcTrgOneSubAll} 
    ### ft(S2F-19) ### ------------- ### Copy-----Code #############################
    lcSrcOneSubID="S2F-19"   # S2F-19
    lcSrcOneFnSubDir="S2F"
        lcSrcOneFnAll="/initrd/mnt/dev_save/MY_/usr-share/My_Dev_/Edit_${lcSrcOneSubDir}/rc.z_${lcSrcOneFnID}.sh"
        lcTrgOneSubAll="/root/my-applications"
        EXR_CopyOneDirect ${lcSrcOneFnID} ${lcSrcOneFnAll} ${lcTrgOneSubAll} 
        lcTrgOneSubAll="/root/my-applications/bin"
        EXR_CopyOneDirect ${lcSrcOneFnID} ${lcSrcOneFnAll} ${lcTrgOneSubAll} 
    ### ft(SFB) ### ------------- ### Copy-----Code #############################
    lcSrcOneFnID="SFB"   # SFB Save File Backup
    lcSrcOneSubDir="SFB"
        lcSrcOneFnAll="/initrd/mnt/dev_save/MY_/usr-share/My_Dev_/Edit_${lcSrcOneSubDir}/rc.z_${lcSrcOneFnID}.sh"
        lcTrgOneSubAll="/root/my-applications"
        EXR_CopyOneDirect ${lcSrcOneFnID} ${lcSrcOneFnAll} ${lcTrgOneSubAll} 
        lcTrgOneSubAll="/root/my-applications/bin"
        EXR_CopyOneDirect ${lcSrcOneFnID} ${lcSrcOneFnAll} ${lcTrgOneSubAll} 
    ### ft(EXR) ### ------------- ### Copy-----Code #############################
    lcSrcOneFnID="EXR"   # EXR
    lcSrcOneSubDir="EXR"
        lcSrcOneFnAll="/initrd/mnt/dev_save/MY_/usr-share/My_Dev_/Edit_${lcSrcOneSubDir}/rc.z_${lcSrcOneFnID}.sh"
        lcTrgOneSubAll="/root/my-applications"
        EXR_CopyOneDirect ${lcSrcOneFnID} ${lcSrcOneFnAll} ${lcTrgOneSubAll} 
        lcTrgOneSubAll="/root/my-applications/bin"
        EXR_CopyOneDirect ${lcSrcOneFnID} ${lcSrcOneFnAll} ${lcTrgOneSubAll} 
    ### ft(GTK) ### ------------- ### Copy-----Code #############################
    lcSrcOneFnID="GTK"   # GTK
    lcSrcOneSubDir="GTK"
        lcSrcOneFnAll="/initrd/mnt/dev_save/MY_/usr-share/My_Dev_/Edit_${lcSrcOneSubDir}/rc.z_${lcSrcOneFnID}.sh"
        lcTrgOneSubAll="/root/my-applications"
        EXR_CopyOneDirect ${lcSrcOneFnID} ${lcSrcOneFnAll} ${lcTrgOneSubAll} 
        lcTrgOneSubAll="/root/my-applications/bin"
        EXR_CopyOneDirect ${lcSrcOneFnID} ${lcSrcOneFnAll} ${lcTrgOneSubAll} 
    ### ft(ABT) ### ------------- ### Copy-----Code #############################
    lcSrcOneFnID="ABT"   # ABT
    lcSrcOneSubDir="ABT"
        lcSrcOneFnAll="/initrd/mnt/dev_save/MY_/usr-share/My_Dev_/Edit_${lcSrcOneSubDir}/rc.z_${lcSrcOneFnID}.sh"
        lcTrgOneSubAll="/root/my-applications"
        EXR_CopyOneDirect ${lcSrcOneFnID} ${lcSrcOneFnAll} ${lcTrgOneSubAll} 
        lcTrgOneSubAll="/root/my-applications/bin"
        EXR_CopyOneDirect ${lcSrcOneFnID} ${lcSrcOneFnAll} ${lcTrgOneSubAll} 
    ### ft(LIB) ### ------------- ### Copy-----Code #############################
    lcSrcOneFnID="LIB-extra"
    lcSrcOneSubDir="LIB"
        lcSrcOneFnAll="/initrd/mnt/dev_save/MY_/usr-share/My_Dev_/Edit_${lcSrcOneSubDir}/${lcSrcOneSubDir}.sh"
        lcTrgOneSubAll="/root/my-applications"
        EXR_CopyOneDirect ${lcSrcOneFnID} ${lcSrcOneFnAll} ${lcTrgOneSubAll} 
        lcTrgOneSubAll="/root/my-applications/bin"
        EXR_CopyOneDirect ${lcSrcOneFnID} ${lcSrcOneFnAll} ${lcTrgOneSubAll} 
    lcSrcOneFnID="LIB-sbr"
    lcSrcOneSubDir="LIB"
        lcSrcOneFnAll="/initrd/mnt/dev_save/MY_/usr-share/My_Dev_/Edit_${lcSrcOneSubDir}/${lcSrcOneSubDir}.sh"
        lcTrgOneSubAll="/root/my-applications"
        EXR_CopyOneDirect ${lcSrcOneFnID} ${lcSrcOneFnAll} ${lcTrgOneSubAll} 
        lcTrgOneSubAll="/root/my-applications/bin"
        EXR_CopyOneDirect ${lcSrcOneFnID} ${lcSrcOneFnAll} ${lcTrgOneSubAll} 
    ### ft(YAF) ### ------------- ### Copy-----Code #############################
    lcSrcOneFnID="YAF_gen"
    lcSrcOneSubDir="YAF"
        lcSrcOneFnAll="/initrd/mnt/dev_save/MY_/usr-share/My_Dev_/Edit_${lcSrcOneSubDir}/${lcSrcOneSubDir}.sh"
        lcTrgOneSubAll="/root/my-applications"
        EXR_CopyOneDirect ${lcSrcOneFnID} ${lcSrcOneFnAll} ${lcTrgOneSubAll} 
        lcTrgOneSubAll="/root/my-applications/bin"
        EXR_CopyOneDirect ${lcSrcOneFnID} ${lcSrcOneFnAll} ${lcTrgOneSubAll} 

    ### ft(TXN) ### test for Copy-All-Code #############################
    lcSrcOneFnID="TXN"   # TXN
    lcSrcOneSubDir="TXN"   # rc.z_TXN
        lcSrcOneFnAll="/initrd/mnt/dev_save/MY_/usr-share/My_Dev_/Edit_${lcSrcOneSubDir}/rc.z_${lcSrcOneFnID}_exe.sh"
        lcTrgOneSubAll="/root/my-applications"
        EXR_CopyOneDirect ${lcSrcOneFnID} ${lcSrcOneFnAll} ${lcTrgOneSubAll} 
        lcTrgOneSubAll="/root/my-applications/bin"
        EXR_CopyOneDirect ${lcSrcOneFnID} ${lcSrcOneFnAll} ${lcTrgOneSubAll} 
    lcSrcOneFnID="TXL"   # TXN
    lcSrcOneSubDir="TXN"   # TXL
        lcSrcOneFnAll="/initrd/mnt/dev_save/MY_/usr-share/My_Dev_/Edit_${lcSrcOneSubDir}/rc.z_${lcSrcOneFnID}_exe.sh"
        lcTrgOneSubAll="/root/my-applications"
        EXR_CopyOneDirect ${lcSrcOneFnID} ${lcSrcOneFnAll} ${lcTrgOneSubAll} 
        lcTrgOneSubAll="/root/my-applications/bin"
        EXR_CopyOneDirect ${lcSrcOneFnID} ${lcSrcOneFnAll} ${lcTrgOneSubAll} 
    lcSrcOneFnID="TXF"   # TXN
    lcSrcOneSubDir="TXN"   # TXF
        lcSrcOneFnAll="/initrd/mnt/dev_save/MY_/usr-share/My_Dev_/Edit_${lcSrcOneSubDir}/rc.z_${lcSrcOneFnID}_exe.sh"
        lcTrgOneSubAll="/root/my-applications"
        EXR_CopyOneDirect ${lcSrcOneFnID} ${lcSrcOneFnAll} ${lcTrgOneSubAll} 
        lcTrgOneSubAll="/root/my-applications/bin"
        EXR_CopyOneDirect ${lcSrcOneFnID} ${lcSrcOneFnAll} ${lcTrgOneSubAll} 
    ### ft(PAK) ### test for Pull All KeyWords  #############################
    lcSrcOneFnID="PAK"
    lcSrcOneSubDir="PAK"
        lcSrcOneFnAll="/initrd/mnt/dev_save/MY_/usr-share/My_Dev_/Edit_${lcSrcOneSubDir}/rc.z_${lcSrcOneFnID}.sh"
        lcTrgOneSubAll="/root/my-applications"
        EXR_CopyOneDirect ${lcSrcOneFnID} ${lcSrcOneFnAll} ${lcTrgOneSubAll} 
        lcTrgOneSubAll="/root/my-applications/bin"
        EXR_CopyOneDirect ${lcSrcOneFnID} ${lcSrcOneFnAll} ${lcTrgOneSubAll} 

    ### begin: SourceFiles not from Dev_Edit ##########################################

    echo ">>> begin: === GEANY ====== GEANY ====== GEANY ==="

    lcSrcOneFnID="GEANY"
        #~ lcSrcOneSubDir="/root/.config/geany/geany.conf"
        lcSrcOneFnAll="/root/.config/geany/geany.conf"
        lcTrgOneSubAll="/root/my-applications"
        EXR_CopyOneDirect ${lcSrcOneFnID} ${lcSrcOneFnAll} ${lcTrgOneSubAll} 
        lcTrgOneSubAll="/root/my-applications/bin"
        EXR_CopyOneDirect ${lcSrcOneFnID} ${lcSrcOneFnAll} ${lcTrgOneSubAll} 

    lcSrcOneFnID="GEANY"
            #~ lcSrcOneSubDir="/root/.config/geany/keybindings.conf"
        lcSrcOneFnAll="/root/.config/geany/keybindings.conf"
        lcTrgOneSubAll="/root/my-applications"
        EXR_CopyOneDirect ${lcSrcOneFnID} ${lcSrcOneFnAll} ${lcTrgOneSubAll} 
        lcTrgOneSubAll="/root/my-applications/bin"
        EXR_CopyOneDirect ${lcSrcOneFnID} ${lcSrcOneFnAll} ${lcTrgOneSubAll} 

    lcSrcOneFnID="GEANY"
            #~ lcSrcOneSubDir="/root/.config/geany/ui_toolbar.xml"
        lcSrcOneFnAll="/root/.config/geany/ui_toolbar.xml"
        lcTrgOneSubAll="/root/my-applications"
        EXR_CopyOneDirect ${lcSrcOneFnID} ${lcSrcOneFnAll} ${lcTrgOneSubAll} 
        lcTrgOneSubAll="/root/my-applications/bin"
        EXR_CopyOneDirect ${lcSrcOneFnID} ${lcSrcOneFnAll} ${lcTrgOneSubAll} 


    ### ft(WRM) #############################

    lcSrcOneFnID="WRM"
    lcSrcOneSubDir="WRMexit"
        lcSrcOneFnAll="/initrd/mnt/dev_save/MY_/usr-share/My_Dev_/Edit_${lcSrcOneSubDir}/rc.z_${lcSrcOneFnID}"
        lcTrgOneSubAll="/root/my-applications"
        EXR_CopyOneDirect ${lcSrcOneFnID} ${lcSrcOneFnAll} ${lcTrgOneSubAll} 
        lcTrgFnDirectP="/root/my-applications/bin"
        EXR_CopyOneDirect ${lcSrcOneFnID} ${lcSrcOneFnAll} ${lcTrgOneSubAll} 

    lcSrcOneFnID="WRM"
    lcSrcOneSubDir="WRMexit"
        lcSrcOneFnAll="/initrd/mnt/dev_save/MY_/usr-share/My_Dev_/Edit_${lcSrcOneSubDir}/rc.z_${lcSrcOneFnID}.sh"
        lcTrgOneSubAll="/root/my-applications"
        EXR_CopyOneDirect ${lcSrcOneFnID} ${lcSrcOneFnAll} ${lcTrgOneSubAll} 
        lcTrgFnDirectP="/root/my-applications/bin"
        EXR_CopyOneDirect ${lcSrcOneFnID} ${lcSrcOneFnAll} ${lcTrgOneSubAll} 

    lcSrcOneFnID="WRM"
    lcSrcOneSubDir="WRMpoweroff"
        lcSrcOneFnAll="/initrd/mnt/dev_save/MY_/usr-share/My_Dev_/Edit_${lcSrcOneSubDir}/rc.z_${lcSrcOneFnID}"
        lcTrgOneSubAll="/root/my-applications"
        EXR_CopyOneDirect ${lcSrcOneFnID} ${lcSrcOneFnAll} ${lcTrgOneSubAll} 
        lcTrgFnDirectP="/root/my-applications/bin"
        EXR_CopyOneDirect ${lcSrcOneFnID} ${lcSrcOneFnAll} ${lcTrgOneSubAll} 

    lcSrcOneFnID="WRM"
    lcSrcOneSubDir="WRMpoweroff"
        lcSrcFnAll="/initrd/mnt/dev_save/MY_/usr-share/My_Dev_/Edit_${lcSrcOneSubDir}/rc.z_${lcSrcOneFnID}.sh"
        lcTrgOneSubAll="/root/my-applications"
        EXR_CopyOneDirect ${lcSrcOneFnID} ${lcSrcOneFnAll} ${lcTrgOneSubAll} 
        lcTrgFnDirectP="/root/my-applications/bin"
        EXR_CopyOneDirect ${lcSrcOneFnID} ${lcSrcOneFnAll} ${lcTrgOneSubAll} 

    lcSrcOneFnID="WRM"
    lcSrcOneSubDir="WRMreboot"
        lcSrcOneFnAll="/initrd/mnt/dev_save/MY_/usr-share/My_Dev_/Edit_${lcSrcOneSubDir}/rc.z_${lcSrcOneFnID}"
        lcTrgOneSubAll="/root/my-applications"
        EXR_CopyOneDirect ${lcSrcOneFnID} ${lcSrcOneFnAll} ${lcTrgOneSubAll} 
        lcTrgFnDirectP="/root/my-applications/bin"
        EXR_CopyOneDirect ${lcSrcOneFnID} ${lcSrcOneFnAll} ${lcTrgOneSubAll} 

    lcSrcOneFnID="WRM"
    lcSrcOneSubDir="WRMreboot"
        lcSrcFnAll="/initrd/mnt/dev_save/MY_/usr-share/My_Dev_/Edit_${lcSrcOneSubDir}/rc.z_${lcSrcOneFnID}.sh"
        lcTrgOneSubAll="/root/my-applications"
        EXR_CopyOneDirect ${lcSrcOneFnID} ${lcSrcOneFnAll} ${lcTrgOneSubAll} 
        lcTrgFnDirectP="/root/my-applications/bin"
        EXR_CopyOneDirect ${lcSrcOneFnID} ${lcSrcOneFnAll} ${lcTrgOneSubAll} 

    ### ft(BMA) #############################
    ###  BMA  ### ### Book Marks_Alpha #################
    ### must copy running /BMA.html, /BMM.html, /BMP.html  

    lcAllFnBase="BMA"		###   /BMA   ### BookMarks_Alpha

        lcSrcFnTitle="BMA"
        EXR_CopySplash	"${lcSrcFnTitle}" && 	sleep .5

        lcSrcFnCopy="/BM*.html"
        lcTrgFnCopy="/root/my-applications"
        cp -v ${lcSrcFnCopy} ${lcTrgFnCopy}
        lcTrgFnCopy="/root/my-applications/bin"
        cp -v ${lcSrcFnCopy} ${lcTrgFnCopy}

        lcSrcFnTitle="/BMA_files"
        EXR_CopySplash	"${lcSrcFnTitle}" && 	sleep .5

        lcSrcFnCopy="/BMA_files"
        lcTrgFnCopy="/root/my-applications"
        cp -v -r ${lcSrcFnCopy} ${lcTrgFnCopy}
        lcTrgFnCopy="/root/my-applications/bin"
        cp -v -r ${lcSrcFnCopy} ${lcTrgFnCopy}

    ### ft(MNU) ### Raw Copy ##########################
    ### must copy running /mnt/home/menu*.*
    lcAllFnBase="MNU"		###  

    lcSrcFnTitle="MNU  Menu.lst"
        EXR_CopySplash	"${lcSrcFnTitle}" && 	sleep .5

    lcSrcFnCopy="/initrd/mnt/dev_save/menu.lst"
        lcTrgFnCopy="/root/my-applications"
        cp -v ${lcSrcFnCopy} ${lcTrgFnCopy} 
        lcTrgFnCopy="/root/my-applications/bin"
        cp -v ${lcSrcFnCopy} ${lcTrgFnCopy} 

    lcSrcFnTitle="MNU  Menu-Advanced.Lst"
        EXR_CopySplash	"${lcSrcFnTitle}" && 	sleep .5

    lcSrcFnCopy="/initrd/mnt/dev_save/menu-advanced.lst"
        lcTrgFnCopy="/root/my-applications"
        cp -v ${lcSrcFnCopy} ${lcTrgFnCopy} 
        lcTrgFnCopy="/root/my-applications/bin"
        cp -v ${lcSrcFnCopy} ${lcTrgFnCopy} 

    lcSrcFnTitle="MNU  Menu-Xp.lst"
        EXR_CopySplash	"${lcSrcFnTitle}" && 	sleep .5

    lcSrcFnCopy="/initrd/mnt/dev_save/menu-xp.lst"
        lcTrgFnCopy="/root/my-applications"
        cp -v ${lcSrcFnCopy} ${lcTrgFnCopy} 
        lcTrgFnCopy="/root/my-applications/bin"
        cp -v ${lcSrcFnCopy} ${lcTrgFnCopy} 

    lcSrcFnTitle="MNU  Menu_Phelp.lst"
        EXR_CopySplash	"${lcSrcFnTitle}" && 	sleep .5

    lcSrcFnCopy="/initrd/mnt/dev_save/menu_phelp.lst"
        lcTrgFnCopy="/root/my-applications"
        cp -v ${lcSrcFnCopy} ${lcTrgFnCopy} 
        lcTrgFnCopy="/root/my-applications/bin"
        cp -v ${lcSrcFnCopy} ${lcTrgFnCopy} 
    lcSrcFnTitle="MNU  Menu-splash.lst"
        EXR_CopySplash	"${lcSrcFnTitle}" && 	sleep .5

    lcSrcFnCopy="/initrd/mnt/dev_save/menu-splash.lst"
        lcTrgFnCopy="/root/my-applications"
        cp -v ${lcSrcFnCopy} ${lcTrgFnCopy} 
        lcTrgFnCopy="/root/my-applications/bin"
        cp -v ${lcSrcFnCopy} ${lcTrgFnCopy} 

    lcSrcFnTitle="MNU  Menu-Boot-*.lst"
        EXR_CopySplash	"${lcSrcFnTitle}" && 	sleep .5

    lcSrcFnCopy="/initrd/mnt/dev_save/menu-Boot-*.lst"
        lcTrgFnCopy="/root/my-applications"
        cp -v ${lcSrcFnCopy} ${lcTrgFnCopy} 
        lcTrgFnCopy="/root/my-applications/bin"
        cp -v ${lcSrcFnCopy} ${lcTrgFnCopy} 


# working gae
    # clear lingering splash
    sleep .5
    kill ${GtkPidCopyOne}
    kill ${GTKPIDCHK} 

###############################################################################
fi ### end: if [ 0 -eq 0 ] # master EXR_Int_Main control : allows Short List Testing
###############################################################################


### <<< end Long Form Copy #############################################
### <<< end Long Form Copy #############################################
### <<< end Long Form Copy #############################################

    lcMsgStr="<<< end: running EXTERNAL.sh ====================="
    Sbr_Str2DevTrm "$lcMsgStr" "2" "3"
    Sbr_Str2DevTrm "$lcMsgStr" "2" "3"
    Sbr_Str2DevTrm "$lcMsgStr" "2" "3"
    sleep 1

} # end: fx(EXR_Main_Run)




########################################################################
### end: EXR SubRoutines ###############################################
########################################################################
########################################################################
### end: EXR SubRoutines ###############################################
########################################################################
########################################################################
### end: EXR SubRoutines ###############################################
########################################################################












####################################################################
#######  start EXR Main()  #########################################
#######  start EXR Main()  #########################################
#######  start EXR Main()  #########################################
####################################################################


########################################################################
########################################################################
########################################################################
###############################
# function (Main()) EXR_Main() ### Falls-Into this main() 
###############################
########################################################################
########################################################################
########################################################################

    export gcEXRDevId="EXR"	

    export gcDtsVer="${gcSysDevDob}"

    #~ EXR_PupState   #   rewritten as 'quick'
    export gcDtsVer="${gcSysDevDob}"

	#~ EXR_SetUp   #   rewritten as 'quick' 
    export gcEXR_lockfile="/tmp/EXR_lockfile"
	touch  ${gcEXR_lockfile} 

### EXR_Main () ###

	### preset in EXR_SetVerDts ()
	#~ gcSysOs="UpupBB-19.03 v:8.0 +20"    ### Manual entry
	#~ gcSysDts="-`date +%y%m%d-%H%M-%S`.dts"  ### grave-mark in date() !!!
	#~ gcSysDts= ${gcSysDts}.dts

	### system Date-Time-Stamp via command 'date'
	###   plus '.dts' extension for selection/deletion as a group by C3C.
	### DTS for archive files.
	### files are Year-Month-Day-Second stamped so no dupelicates.
	### use the `" grave mark, not single "'" quote mark.

#########################################################################
echo "### in EXR_Main (0) ###"
#########################################################################

lcFileEXRname="Main Backup : Edit-3-Root"   # A
 
###=======  start MAIN Gui   ==============================================

# Selection XML GUI Not Required 

###=======  start MAIN Screen   ====================
###
### all "echo" will appear in BASH Terminal Screen.
### test code via Geany, "Execute" , Terminal .

###=== MAIN splash ===###
### precedes the group of all EXR_Copy

lcMsgStr="...EXR : $lcFileEXRname : v:${gcDtsVer} terminal trace"
echo "=== $lcMsgStr"	### terminal display tracer



### (3) ### main () splash is "background" for all 'action' splashes.
/usr/lib/gtkdialog/box_splash -fg yellow -bg darkred -close never -text "\
.            EXR.sh  : v:${gcDtsVer}
.
.                            
.                Running:  EXR.sh
.                              
.
.
.
.
.
....................................................................." &
### 11 lines ### ending pos 72
### (3) ### main () splash is "background" for all 'action' splashes.

    sleep 1
	pidx=$!
	GTKPID0MAIN=$!
	### no 'kill' now.  
	### will kill ${GTKPID0MAIN}  after prg runs through. 
    sleep .1




### above method expands main splash vertical height
### so to allow for intermediate green progress splash.


########################################################################
########################################################################
        echo ">>> fx(EXR_Main_Run)  ###"

            EXR_Main_Run   ### call to sbr fx(EXR_Main_Run) 

        echo "<<< fx(EXR_Main_Run)  ###"
########################################################################
########################################################################



#########################################
###	EXR funxtion is to backup all these modules into "/root/my-applications"
###	method:
### 	gather param "lcParamCopy" 
###		execute scripts copy into target subdir 
#########################################

### now, a sequence of "Action blocks"  for  "copy" .
### each triggers a "copy-check" .
### each splash is small and is written over the previous splash .
### 'kill' are delayed so that previous splash remains on screen longer.

#########################################


### call EXR_Copy(0)
    ### (0)
    ### "${1}" ### this is the only var to change for each EXR process.

#~ echo
#~ echo "+++++++++++++++++++++++++++++++++++
#~ echo "### Build Fn'P'rimary and send as param to 'EXR_Copy' "
#~ echo "+++++++++++++++++++++++++++++++++++

###################################################################

    # this ONE kill can clear all standard EXR_CopySplash 
    # in case we forgot one
    #~ sleep .5
    #~ kill ${GTKPIDCHK} 

###   DONE  ###########################################################

lcFileEXRname="EXR.sh" 
#------------------------------------------------------------------------
 	/usr/lib/gtkdialog/box_splash -fg yellow -bg darkgreen-close never -text "\
. 	
. 	       $lcFileEXRname               
. 	   DONE:---DONE:---DONE:---   
.
. 	                                      " &
#------------------------------------------------------------------------
    sleep 2
	GTKPID0D3=$!

    kill ${GTKPID0D3}
    
echo "==========> kill ---Done ---"

    sleep .1
    kill ${GTKPID0MAIN}   ### main

    # quick EXR_CleanUp
	rm -r "${gcEXR_lockfile}"


echo "<<< EXR main () : DONE"

    ### system funxtion "sleep" will timeout and echo "terminated"

# can only 'return' to a source or script
# XXX return 0
# req clean flow back to MGN
# XXX exit 0 

    ### Do Not RESTART script auto ###
    ### NO !!!   do not call restart
    ### MGN is the 'caller' 
    ### MGN will handle "ReStart"
exit 0

########################################################################
### END of EXR script ### end of main() ###
########################################################################
########################################################################
### END of EXR script ### end of main() ###
########################################################################
########################################################################
### END of EXR script ### end of main() ###
########################################################################

