#! /bin/bash
#
# /initrd/mnt/dev_save/MY_/usr-share/My_Dev_/Edit_MNT/rc.z_MNT.sh
# /root/Startup/my_mount_drv.sh
# /initrd/mnt/dev_save/MY_/usr-share/My_Dev_/Edit_pMNT/rc.z_pMNT.sh
# /initrd/mnt/dev_save/MY_/usr-share/My_Dev_/Edit_uMNT/rc.z_uMNT.sh
#
# /var/log/my_mount_drv.log
# purpose: continuing log of test for mounting a Drive/USB devices
#
###^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^
#(: System Developer Initial DOB 
export gcSysDevDob="220910-1619"		
###^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^
#(: System Developer ID name of this Linux BASH script
export gcSysDevId="MNT"	
###^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^

#;;;;;;;;;;;;;;;;;;;;;;;
### 220318-0850
### 220322-0923
#;;;;;;;;;;;;;;;;;;;;;;;




#;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
#;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
#;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
function MNT_pMount() {
lnDummy=0

    lnDummy=0
	#
	#~ MGN_ClearFlags	# clear lockfile so that Warm Reboot can run.
	#
#-----------------------------------------------------------------------
/usr/lib/gtkdialog/box_splash -fg orange -bg green -close never -text "\
.
.     Quick Mount        
.         ${1}  
.                                                      "&
#------------------------------------------------------------------------
    RETVAL=$?
	GTKPIDMAIN0=$!
    #

echo ">>> Mount ===== ${1}."
echo ">>> Mount ===== ${1}." > /dev/console

mkdir -p /mnt/${1} drv 

echo "======================================" >> ${lcMntLog} 
echo "${lcMntLog}   /dev/${1}  /mnt/${1}  " 
echo "${lcMntLog}   /dev/${1}  /mnt/${1}  " >> ${lcMntLog} 

	lcDirName="/root"
	if [ -d ${lcDirName} ] ; then 
		lcMsgStr="=== ${lcDirName} OK ===" && echo "$lcMsgStr"
	else
		lcMsgStr="=== ${lcDirName} NOT ===" && echo "$lcMsgStr"
		exit 0
	fi		
#~ read
#~ exit 0

# mount    
# orig:  /dev/${1} /mnt/${1} && echo "Success=====${1} ."  >> /mnt/home/my_mount_drv.log || echo "Fail."  >> /mnt/home/my_mount_drv.log

echo " "  >> ${lcMntLog}
echo ">>>>>>>"   >> ${lcMntLog}
echo " "  >> ${lcMntLog}


echo "First try: mount /dev/${1} /mnt/${1} " 
echo "First try: mount /dev/${1} /mnt/${1} " >> ${lcMntLog}
mount         /dev/${1} /mnt/${1} && echo "Success === First ${1}." >> ${lcMntLog} 

echo "EXT3 try: mount /dev/${1} /mnt/${1}"  
echo "EXT3 try: mount /dev/${1} /mnt/${1}"  >> ${lcMntLog}
mount -t ext3 /dev/${1} /mnt/${1} && echo "Success === EXT3 ${1}."  >> ${lcMntLog} 

echo "VFAT try: mount /dev/${1} /mnt/${1}"  
echo "VFAT try: mount /dev/${1} /mnt/${1}"  >> ${lcMntLog}
mount -t vfat /dev/${1} /mnt/${1} && echo "Success === VFAT ${1}."  >> ${lcMntLog} 

echo " "  >> ${lcMntLog}
echo "<<<<<<<"   >> ${lcMntLog}
echo " "  >> ${lcMntLog}

	sleep .1
# hold:	kill ${GTKPIDMAIN0}

} # end: fx(GTK_pMount)

export -f MNT_pMount

#;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
#;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
#;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;







#=== Main() ===


#(: ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
#(: fs(rc.z_MNT.sh)
#(: called by: MGN via "MntAll" to "MNT+" 
#(: param: none
#(: purpose: 
#(: calls: 
#(: method: repeats call to internal subroutine with sequential HD param.
#(: sends: 
#(: rationale: 
#(: note : 
#(:		If drive exists, unmounted, then mount is Success
#(:		If drive not exists, then mount is Fail	
#(:


lcMntLog="/mnt/home/my_mount_drv.log"
lcMntDrv="SDA1"

echo "*******************************************" 	>	${lcMntLog} 
echo "--- ${lcMntLog} log --- " 					>>	${lcMntLog} 
echo "*** `date` *** ${0} ***" 						>>	${lcMntLog} 
echo "******************************************* " >>	${lcMntLog} 


#;;; begin Main looping ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

MNT_pMount "sda1"
MNT_pMount "sda2"
MNT_pMount "sdb1"
MNT_pMount "sdc1"
MNT_pMount "sdd1"
MNT_pMount "sde1"
MNT_pMount "sdf1"
MNT_pMount "sdg1"
MNT_pMount "sdh1"
MNT_pMount "sdi1"
MNT_pMount "sdj1"
MNT_pMount "sdk1"
MNT_pMount "sdl1"

echo "--- close MOUNT --- " >> ${lcMntLog}
echo "------------------ " >> ${lcMntLog}

mount -l >> ${lcMntLog}
echo "--- close LIST --- " >> ${lcMntLog}
echo "------------------ " >> ${lcMntLog}

	kill ${GTKPIDMAIN0}

#;;; end Main ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

##~ echo "Second try: mount -t ext3 /dev/sde1 /mnt/sde1 "  >> /mnt/home/my_mount_drv.log
##~ mount -t ext3 /dev/sde1 /mnt/sde1 && echo "Success."  >> /mnt/home/my_mount_drv.log || echo "Fail."  >> /mnt/home/my_mount_drv.log

### only for testing :   geany  ${lcMntLog}
echo "************************************************************ "
echo "--- geany loading ${lcMntLog} --- will require 'reload'  " 
echo "************************************************************ "
#~ geany  ${lcMntLog}	

###


### Runs OK from external call, original top of stack. 
### Not OK called from within MGN.sh with all code internal to rc.z_MNT.sh
### problem may be function is not at top of stack. 

#~ mkdir -p /mnt/sdd1 
#~ echo "First try: mount /dev/sdd1 /mnt/sdd1" 
#~ mount /dev/sdd1 /mnt/sdd1 && echo "Success." || echo "Fail." 
#~ echo "Second try: mount -t ext3 /dev/sdd1 /mnt/sdd1" 
#~ mount -t ext3 /dev/sdd1 /mnt/sdd1 && echo "Success." || echo "Fail."

# /etc/rc.local/mount_drv.sh
# test program on /etc/rc.local
# /tmp/mount_drv.log has info
#

#~ mkdir -p /mnt/sdd1 

#~ echo "First try: mount /dev/sdd1 /mnt/sdd1 " >> /mnt/home/my_mount_drv.log  
#~ mount /dev/sdd1 /mnt/sdd1 && echo "Success."  >> /mnt/home/my_mount_drv.log || echo "Fail."  >> /mnt/home/my_mount_drv.log
#~ echo "Second try: mount /dev/sdd1 /mnt/sdd1"  >> /mnt/home/my_mount_drv.log
#~ mount -t ext3 /dev/sdd1 /mnt/sdd1 && echo "Success."  >> /mnt/home/my_mount_drv.log || echo "Fail."  >> /mnt/home/my_mount_drv.log

#~ echo "Second try: mount /dev/sdc1 /mnt/sdc1"  >> /mnt/home/my_mount_drv.log
#~ mount -t vfat /dev/sdc1 /mnt/sdc1 && echo "Success."  >> /mnt/home/my_mount_drv.log || echo "Fail."  >> /mnt/home/my_mount_drv.log

#~ mymountdrv="sdc1"
#~ mkdir -p /mnt/sdc1 drv 
#~ echo "First try: mount /dev/sdc1 /mnt/sdc1  " >> /mnt/home/my_mount_drv.log  
#~ mount /dev/sdc1 /mnt/sdc1 && echo "Success."  >> /mnt/home/my_mount_drv.log || echo "Fail."  >> /mnt/home/my_mount_drv.log
#~ 


#~ # yassm
#~ for p in $(awk '$2 ~ "YASSM" {print $2}' /proc/mounts); do
	#~ fuser -mk $p 
	#~ umount $p
#~ done
#~ #01micko: umount is not a reliable script, so have to use umount-FULL
#~ #also see shinobar's msg in http://murga-linux.com/puppy/viewtopic.php?p=605451#605451
#~ umount-FULL -a -t cifs,smbfs,nfs,sshfs
#~ ###


#~ ##############################################################################
#~ ##############################################################################
#~ ##############################################################################
#~ #;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
#~ #(: fx(xxxSys_MGN_pMount)		# ACTIVE NOT
#~ #(: called by : ft(EXIT:MntAll+) for external 
#~ #(: purpose :  Mount All HardDrives 
#~ #(: receives param :  "sda1" "sdb1" "sdc1" etc
#~ #(: returns : back to ft(EXIT:"MntAll+") 
#~ #(: note:

#~ function xxxSys_MGN_pMount() {		# MGN call for each HD, for "mount" @ 3 times. 
	#~ #
    #~ lnDummy=0
	#~ #
	# XXX MGN_ClearFlags	# clear lockfile so that Warm Reboot can run.
	#~ #
#~ lcMsgStr="call system 'mount' for ${1} internal"
#~ #-----------------------------------------------------------------------
#~ /usr/lib/gtkdialog/box_splash -fg yellow -bg green -close never -text " ${lcMsgStr} " &
#~ #------------------------------------------------------------------------
    #~ RETVAL=$?
	#~ GTKPIDMAIN=$!
    #~ #

#~ echo ">>> Sys_MGN_pMount calls 'mount' ===== ${1}." 

	#~ # setup for LogFile
		#~ # log file is handled by ft(EXIT:"pMntAll+") 
		#~ mkdir -p /mnt/${1} drv 
		#~ echo "======================================" >> /mnt/home/my_mount_drv.log  
		#~ echo "my_mount_drv.log /dev/${1} /mnt/${1}  " >> /mnt/home/my_mount_drv.log  
		#~ # mount /dev/${1} /mnt/${1} && echo "Success=====${1} ."  >> /mnt/home/my_mount_drv.log || echo "Fail."  >> /mnt/home/my_mount_drv.log

#~ echo "First try: mount /dev/${1} /mnt/${1} " >> /mnt/home/my_mount_drv.log  
#~ mount         /dev/${1} /mnt/${1} && echo "Success."  >> /mnt/home/my_mount_drv.log || echo "Fail."  >> /mnt/home/my_mount_drv.log

#~ echo "EXT3 try: mount /dev/${1} /mnt/${1}"  >> /mnt/home/my_mount_drv.log
#~ mount -t ext3 /dev/${1} /mnt/${1} && echo "Success."  >> /mnt/home/my_mount_drv.log || echo "Fail."  >> /mnt/home/my_mount_drv.log

#~ echo "VFAT try: mount /dev/${1} /mnt/${1}"  >> /mnt/home/my_mount_drv.log
#~ mount -t vfat /dev/${1} /mnt/${1} && echo "Success."  >> /mnt/home/my_mount_drv.log || echo "Fail."  >> /mnt/home/my_mount_drv.log

#~ echo "<<< Sys_MGN_pMount calls 'mount' ===== ${1} :" 

	#~ sleep 1
	#~ kill ${GTKPIDMAIN}

#~ sleep 1

#~ # log file is handled by ft(EXIT:"pMntAll+") 

#~ } # end: fx(xxxSys_MGN_pMount)

#~ #(: export subroutine filename before calling 
#~ export -f xxxSys_MGN_pMount

